from docstring_inheritance import GoogleDocstringInheritanceMeta


class Person(metaclass=GoogleDocstringInheritanceMeta):
    def __init__(self, fname: str, lname: str) -> None:
        """This is a person

        Args:
            fname (str): first name
            lname (str): last name
        """
        self.fname = fname
        self.lname = lname

        self.print_main_greeting()

    def print_main_greeting(self):
        print(f'Welcome {self.fname} {self.lname}!')


class Student(Person):
    def __init__(self, fname: str, lname: str, semester: int) -> None:
        """This is a student

        Args:
            semester (int): Students semester
        """
        super().__init__(fname, lname)
        self.semester = semester

        self.print_greeting()

    def print_greeting(self):
        print(f'Welcome {self.fname} {self.lname} to the {str(self.semester)}. semester!')
